from pgm import render, log, widget
from pgm.layout import window
from pgm.form import rectangle, image, color
from pgm.timing import controller, modifier, keyframe
import time, sys, pgmrender, gobject

INCREMENT = 0.5

render.init('opengl1')
#log.set_level(log.DEBUG)

#rotation = 0.
#increment = INCREMENT
style = pgmrender.LAYOUT_SCALED
win = None
rect1 = None

# def rotate(rect=None):
#     global rotation, increment
#     rotation += increment
#     rect.rotation = (rotation*1.5, rotation, 0.)

def key_pressed(event):
    global win
    if event.keyval == pgmrender.KEY_ESCAPE:
        win.main_quit()
    elif event.keyval == 50: #A
        r = rectangle.Rectangle()
        r.position = (100,100)
        win.add(r)

def button_pressed(event):
    global win, rect1, style
    if style == pgmrender.LAYOUT_SCALED:
        style = pgmrender.LAYOUT_FILLED
        rect1.aspect_style = style
    elif style == pgmrender.LAYOUT_FILLED:
        style = pgmrender.LAYOUT_SCALED
        rect1.aspect_style = style

def main(args):
    global win, rect1
    title = 'Image'

    if len(args) != 1:
        print 'Usage: %s image' % sys.argv[0]
        return 1
    
    img = image.Image(args[0])

    rect1_back = rectangle.Rectangle(size=(300,300), position=(250,150),
				     paint=color.Color((0,0,255,150)))
    rect1_back.ordering = widget.FAR
    rect1 = rectangle.Rectangle(size=(300,300))
    rect1.media = img
    rect1.aspect_style = pgmrender.LAYOUT_FILLED
    rect1.opacity = 150
    rect2 = rectangle.Rectangle(size=(200, 200))
    rect2.media = img
    rect3 = rectangle.Rectangle(size=(100, 100))
    rect3.media = img
    rect4 = rectangle.Rectangle(size=(100, 100))
    rect4.media = img

    rect1.position=(250, 150)
    rect2.position=(25, 25)
    rect4.position=(50, 50)
    rect2.tz = 0
    rect4.tz = 50
    rect4.opacity = 100

    win = window.Window(size=(800,600), scale_mode=window.ADJUST)
    win.title = title
    win.add(rect1_back)
    win.add(rect1)
    win.add(rect2)
    rect2.ordering = widget.FAR
    win.add(rect4)

    win.sig_key_press_event.connect(key_pressed)
    win.sig_button_press_event.connect(button_pressed)
    win.sig_exit_event.connect(lambda _: win.main_quit)

    win.add(rect3)
    rect3.position=(650, 450)
    rect1.y_align = 1.0
    
    timeline = [keyframe.KeyFrame(0.0, 0.0),
                keyframe.KeyFrame(180.0, 1.0)]
    mdf_pos = modifier.Modifier([rect1], 'rz', timeline)
    ctrl = controller.Controller(begin=0, duration=1300,
                                 resolution=15,
                                 repeat_count=100,
                                 repeat_behavior=controller.REVERSE,
                                 modifiers=[mdf_pos],
                                 interpolation = controller.SINUSOIDAL)

    #ctrl.start()
    rect1.media = img

    # Start the loop
    gobject.timeout_add(50, win.update)
    win.main()

if __name__ == '__main__':
    sys.exit(main(sys.argv[1:]))
